#ifndef SIMPLEX_H
#define SIMPLEX_H

#include <vector>
#include "gmpxx.h"
#include <stdio.h>
#include <string>

class SIMPLEX_TYPE {

public:

  // A:  M+1 x N+1

  // N variables
  // M = m1+m2+m3

  // first row: objective function
  // m1: # <=
  // m2: # >=
  // m3: # ==

  static const int OK = 0;
  static const int UNBOUNDED = 1;
  static const int NO_SOLUTION = -1;
  static const int TIMEOUT = 2;
  
  static int solve(std::vector< std::vector<SIMPLEX_NUMBER> > &A, int m1, int m2, int m3,
		   SIMPLEX_NUMBER &opt_val, std::vector<SIMPLEX_NUMBER> &result_vec);
};

#endif
