// minmaxlp driver: reads n m matrix from stdin and solves the minmax lp

// written by Michael Buro (2003)
// license: GPL

#include <iostream>
#include "MinMaxLP.H"

using namespace std;

int main(int argc, char **argv)
{
  vector<double> input, output;
  int n, m;
  int res;
  double max_val;

#if 0

  // generate and solve random instances
  
  srand(time(0));

  if (argc != 2 || atoi(argv[1]) < 1) {
    cerr << "usage: lp n" << endl;
    exit(20);
  }

  n = m = atoi(argv[1]);
  int num = n*m;
  
  for (int i=0; i < num; ++i) {
    input.push_back(rand()/double(RAND_MAX));
  }

  for (int i=0; i < 100; ++i) 
    res = minmaxlp(n, m, input, output, max_val);
  
#else

  // read instance from file:  n  m  matrix
  
  if (argc != 1) {
    cerr << "usage: lp < lp-file" << endl;
    exit(20);
  }

  cin >> n;
  cin >> m;

  if (!cin || n <= 0 || m <= 0) { cerr << "m,n corrupt" << endl; exit(20); }
  
  int num = n*m;
  
  for (int i=0; i < num; ++i) {
    double x;
    cin >> x;
    if (!cin) { cerr << "matrix corrupt" << endl; exit(20); }    
    input.push_back(x);
  }

  if (!cin) { cerr << "input error" << endl; exit(20); }

#endif

  res = minmaxlp(n, m, input, output, max_val);

  if (res) {

    cerr << "problems" << endl;

  } else {

    cout << "solution:" << endl;
    for (unsigned int i = 0; i < output.size(); ++i) {
      cout << output[i] << " ";
    }
    cout << endl;
    cout << "val= " << max_val << endl;
  }

}
